package com.gemho.netty.controller;

import cn.hutool.json.JSONUtil;
import com.gemho.netty.util.CRC16Util;
import com.gemho.netty.util.MapUtils;
import com.gemho.netty.util.ParamUtil;
import com.gemho.netty.util.StringUtil;
import io.netty.buffer.ByteBuf;
import io.netty.buffer.Unpooled;
import io.netty.channel.Channel;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.LinkedHashMap;
import java.util.Map;

@RestController
public class SocketController {


    private static String CLEAR_CODE = "0000000400000650";

    private static String DISPLAY_CODE = "0001";

    // key:313233343536373839383736353433   16进制DTU码
    // code: 03
    @RequestMapping("/clear")
    public String clearDiaplay(String key, String code) {
        code = code + CLEAR_CODE;
        int i = CRC16Util.calcCrc16(StringUtil.hexString2Bytes(code));
        System.out.println("=============" + StringUtil.encodeHEX(i));
        System.out.println("=============" + StringUtil.hexString2Bytes((code + StringUtil.encodeHEX(i)).toUpperCase()));
        code = (code + StringUtil.encodeHEX(i)).toUpperCase();
        // 内容封装
        ByteBuf bufff = Unpooled.buffer();
        //  bufff.clear();
        bufff.writeBytes(StringUtil.hexString2Bytes(code));
        // 获取通道
        Channel mapChannel = MapUtils.getMapChannel(key);
        mapChannel.writeAndFlush(bufff);
        return "success";
    }

    // 01 00 01 00 0E 36 05 30 CE C2 B6 C8 B7 38
    // key:313233343536373839383736353433   16进制DTU码
    // code: 03
    // x: 54  16进制
    // y: 5   16禁止
    // font:  30字体大小
    // content: 温度
    @RequestMapping("/display")
    public String display(String key, String code, Integer x, Integer y, String font, String content) {
        try{
            // 指令处理
            String xHex = Integer.toHexString(x).length() == 1? "0"+ Integer.toHexString(x) : Integer.toHexString(x);
            String yHex = Integer.toHexString(y).length() == 1? "0"+ Integer.toHexString(y) : Integer.toHexString(y);
            String contentByte = StringUtil.enUnicode(content);
            byte[] contentB = StringUtil.hexString2Bytes(contentByte);
            String lenHex = StringUtil.encodeHEX(contentB.length + 10);
            lenHex = StringUtil.hightAddZero(lenHex);
            code = code + DISPLAY_CODE + lenHex + xHex + yHex + font + StringUtil.bytesToHexString(contentB);
            code = code + StringUtil.encodeHEX(CRC16Util.calcCrc16(StringUtil.hexString2Bytes(code)));
            System.out.println("下发指令==============" + code.toUpperCase());
            // 数据封装
            ByteBuf bufff = Unpooled.buffer();
            bufff.writeBytes(StringUtil.hexString2Bytes(code));
            // 获取通道
            Channel mapChannel = MapUtils.getMapChannel(key);
            mapChannel.writeAndFlush(bufff);
            // 执行失败使用
            if (ParamUtil.findMap(mapChannel.remoteAddress()) == null) {
                Map<Integer, ByteBuf> map = new LinkedHashMap<>();
                map.put(1, bufff.retain());
                ParamUtil.addMap(mapChannel.remoteAddress(), map);
            }
            return "success";
        }catch(Exception e) {
            e.printStackTrace();
            return null;
        }
    }

}
