package com.gemho.netty.controller;

import cn.hutool.json.JSONUtil;
import com.gemho.netty.util.*;
import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.ChannelInboundHandlerAdapter;

import java.util.Map;
import java.util.Set;

public class nettyHandler extends ChannelInboundHandlerAdapter {

    @Override
    public void channelActive(ChannelHandlerContext ctx) throws Exception {
        System.out.println("当前连接信息:" + ctx.channel().remoteAddress());
    }

    @Override
    public void channelRead(ChannelHandlerContext ctx, Object msg) throws Exception {
        /*System.out.println(msg.toString() + "========================");
        if (msg.toString().length() == 8) {
            System.out.println("=====================1");
            msg = StringUtil.bytesToHexString(msg.toString().getBytes());
        }else {
            System.out.println("=====================2");
            msg = msg.toString();
        }*/
        System.out.println("=================" + StringUtil.bytesToHexString(StringUtil.hexString2Bytes(StringUtil.splitString(msg.toString()))));
        if (msg.toString().length() == 30) {
            MapUtils.addMap(msg.toString(), ctx.channel());
        }else {
            byte[] bys = StringUtil.hexString2Bytes(msg.toString());
            int i = CRC16Util.calcCrc16(bys, 0, 6);
            if (StringUtil.hightAddZero(Integer.toHexString(i).toUpperCase()).equals(StringUtil.bytesToHexString(bys).substring(12))){
                System.out.println("CRC校验通过!");
                /*src：byte源数组
                srcPos：截取源byte数组起始位置（0位置有效）
                dest,：byte目的数组（截取后存放的数组）
                destPos：截取后存放的数组起始位置（0位置有效）
                length：截取的数据长度*/
                byte[] newBys = new byte[2];
                System.arraycopy(bys, 3, newBys, 0, 2);
                if ("0001".equals(StringUtil.bytesToHexString(newBys))) {
                    System.out.println("正常. 大屏接收到数据");
                } else {
                    // 执行失败
                    Map<Integer, ByteBuf> map = ParamUtil.findMap(ctx.channel().remoteAddress());
                    if (map != null) {
                        Set<Integer> integers = map.keySet();
                        for (Integer key : integers) {
                            for (int j = 0; j < 4 - key; j++) {
                                if (key == 3) {
                                    ParamUtil.removeMap(ctx.channel().remoteAddress());
                                    System.out.println(ctx.channel().remoteAddress() + "错误. 大屏未接收到数据");
                                    return ;
                                }else {
                                    ByteBuf byteBuf = map.get(key);
                                    System.out.println("发送数据==============" + JSONUtil.toJsonStr(byteBuf));
                                    ctx.channel().write(byteBuf.retain());
                                    map.put(key+1, map.get(key).retain());
                                    map.remove(ctx.channel().remoteAddress());
                                    ParamUtil.updateMap(ctx.channel().remoteAddress(), map);
                                    System.out.println("repeat......." + key);
                                }
                            }
                        }
                    }
                   // System.out.println(ctx.channel().remoteAddress() + "错误. 大屏未接收到数据");
                }
            }else {
                System.out.println("CRC校验失败！");
            }
        }
    }

    @Override
    public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) throws Exception {
        System.out.println("异常信息:" + cause.getMessage());
    }

    // 心跳处理
    @Override
    public void userEventTriggered(ChannelHandlerContext ctx, Object evt) throws Exception {

    }




}