package com.gemho.netty.controller;

import com.gemho.netty.util.DecodeUtil;
import io.netty.bootstrap.ServerBootstrap;
import io.netty.channel.ChannelInitializer;
import io.netty.channel.ChannelOption;
import io.netty.channel.nio.NioEventLoopGroup;
import io.netty.channel.socket.SocketChannel;
import io.netty.channel.socket.nio.NioServerSocketChannel;
import io.netty.handler.codec.string.StringEncoder;
import io.netty.util.CharsetUtil;

public class nettyServer {

    public nettyServer(int port) {
        this.start(port);
    }



    public void start(int port)  {
        System.out.println("启动成功, 当前监听: " + port);
        ServerBootstrap b = new ServerBootstrap();
        NioEventLoopGroup group = new NioEventLoopGroup();
        b.group(group)
                .channel(NioServerSocketChannel.class)
                .childHandler(new ChannelInitializer<SocketChannel>() {
                    @Override
                    public void initChannel(SocketChannel ch)
                            throws Exception {
                        System.out.println("initChannel ch:" + ch);
                        ch.pipeline()
                                .addLast("decoder", new DecodeUtil())
                                .addLast("encoder", new StringEncoder(CharsetUtil.UTF_8))
                                .addLast("handler", new nettyHandler());
                    }
                })
                .option(ChannelOption.SO_BACKLOG, 128) // determining the number of connections queued
                .childOption(ChannelOption.SO_KEEPALIVE, Boolean.TRUE);

        try{
            b.bind(port).sync();
        }catch(Exception e) {
            e.printStackTrace();
        }
    }
}
